set define off
set verify off
set serveroutput on size 1000000
set feedback off
WHENEVER SQLERROR EXIT SQL.SQLCODE ROLLBACK
begin wwv_flow.g_import_in_progress := true; end; 
/
 
--       AAAA       PPPPP   EEEEEE  XX      XX
--      AA  AA      PP  PP  EE       XX    XX
--     AA    AA     PP  PP  EE        XX  XX
--    AAAAAAAAAA    PPPPP   EEEE       XXXX
--   AA        AA   PP      EE        XX  XX
--  AA          AA  PP      EE       XX    XX
--  AA          AA  PP      EEEEEE  XX      XX
prompt  Set Credentials...
 
begin
 
  -- Assumes you are running the script connected to SQL*Plus as the Oracle user APEX_040000 or as the owner (parsing schema) of the application.
  wwv_flow_api.set_security_group_id(p_security_group_id=>nvl(wwv_flow_application_install.get_workspace_id,8371361722743396270));
 
end;
/

begin wwv_flow.g_import_in_progress := true; end;
/
begin 

select value into wwv_flow_api.g_nls_numeric_chars from nls_session_parameters where parameter='NLS_NUMERIC_CHARACTERS';

end;

/
begin execute immediate 'alter session set nls_numeric_characters=''.,''';

end;

/
begin wwv_flow.g_browser_language := 'en'; end;
/
prompt  Check Compatibility...
 
begin
 
-- This date identifies the minimum version required to import this file.
wwv_flow_api.set_version(p_version_yyyy_mm_dd=>'2010.05.13');
 
end;
/

prompt  Set Application ID...
 
begin
 
   -- SET APPLICATION ID
   wwv_flow.g_flow_id := nvl(wwv_flow_application_install.get_application_id,49710);
   wwv_flow_api.g_id_offset := nvl(wwv_flow_application_install.get_offset,0);
null;
 
end;
/

prompt  ...plugins
--
--application/shared_components/plugins/dynamic_action/com_skillbuilders_sbdp_save_value
 
begin
 
wwv_flow_api.create_plugin (
  p_id => 28053058825171692526 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_type => 'DYNAMIC ACTION'
 ,p_name => 'COM_SKILLBUILDERS_SBDP_SAVE_VALUE'
 ,p_display_name => 'SkillBuilders Save Value on Cascade'
 ,p_category => 'EXECUTE'
 ,p_image_prefix => '#PLUGIN_PREFIX#'
 ,p_plsql_code => 
'FUNCTION apex_save_value_render ('||chr(10)||
'   p_dynamic_action IN APEX_PLUGIN.T_DYNAMIC_ACTION,'||chr(10)||
'   p_plugin         IN APEX_PLUGIN.T_PLUGIN '||chr(10)||
')'||chr(10)||
''||chr(10)||
'   RETURN APEX_PLUGIN.T_DYNAMIC_ACTION_RENDER_RESULT'||chr(10)||
'   '||chr(10)||
'IS'||chr(10)||
''||chr(10)||
'   l_result APEX_PLUGIN.T_DYNAMIC_ACTION_RENDER_RESULT;'||chr(10)||
'   l_crlf   CHAR(2) := CHR(13)||CHR(10);'||chr(10)||
''||chr(10)||
'BEGIN'||chr(10)||
''||chr(10)||
'   IF apex_application.g_debug'||chr(10)||
'   THEN'||chr(10)||
'      apex_plugin_util.debug_dynamic_action('||chr(10)||
'         p_plug'||
'in         => p_plugin,'||chr(10)||
'         p_dynamic_action => p_dynamic_action '||chr(10)||
'      );'||chr(10)||
'   END IF;'||chr(10)||
'   '||chr(10)||
'   apex_javascript.add_library('||chr(10)||
'      p_name      => ''com_skillbuilders_sbdp_save_value_on_cascade.min'','||chr(10)||
'      p_directory => p_plugin.file_prefix,'||chr(10)||
'      p_version   => NULL '||chr(10)||
'   );'||chr(10)||
''||chr(10)||
'   l_result.javascript_function := '||chr(10)||
'      ''function(){'' || l_crlf ||'||chr(10)||
'      ''   if (this.browserEvent.type === ''''ready''''){'' '||
'|| l_crlf ||'||chr(10)||
'      ''      apex.jQuery(document).apex_save_value_on_casdade({''''apexThis'''': this});'' || l_crlf ||'||chr(10)||
'      ''   }'' || l_crlf ||'||chr(10)||
'      ''}'';'||chr(10)||
''||chr(10)||
'   RETURN l_result;'||chr(10)||
'    '||chr(10)||
'END apex_save_value_render;'
 ,p_render_function => 'apex_save_value_render'
 ,p_standard_attributes => 'ITEM:REQUIRED'
 ,p_help_text => '<br />'||chr(10)||
''
 ,p_version_identifier => '1.1'
  );
null;
 
end;
/

 
begin
 
wwv_flow_api.g_varchar2_table := wwv_flow_api.empty_varchar2_table;
wwv_flow_api.g_varchar2_table(1) := '2866756E6374696F6E2861297B612E776964676574282275692E617065785F736176655F76616C75655F6F6E5F63617364616465222C7B6F7074696F6E733A7B61706578546869733A7B7D2C736176655461673A22617065782D76616C75652D73617665';
wwv_flow_api.g_varchar2_table(2) := '64227D2C5F6372656174653A66756E6374696F6E28297B76617220623D746869733B622E6F7074696F6E732E61706578546869732E6166666563746564456C656D656E74732E656163682866756E6374696F6E28297B76617220633D612874686973293B';
wwv_flow_api.g_varchar2_table(3) := '696628247828227064656275672229297B617065782E64656275672822496E697469616C697A696E6720536176652056616C7565206F6E204361736361646520666F7220222B632E61747472282269642229297D632E6461746128622E6F7074696F6E73';
wwv_flow_api.g_varchar2_table(4) := '2E736176655461672C247628632E6174747228226964222929292E62696E6428226368616E6765222C66756E6374696F6E28297B622E5F7361766556616C75652863297D292E62696E64282261706578616674657272656672657368222C66756E637469';
wwv_flow_api.g_varchar2_table(5) := '6F6E28297B622E5F726573746F726556616C75652863297D297D297D2C5F7361766556616C75653A66756E6374696F6E2862297B76617220633D746869733B696628622E686173436C617373282273687574746C652229297B632E5F7361766553687574';
wwv_flow_api.g_varchar2_table(6) := '746C6556616C75652862297D656C73657B632E5F736176654F7468657256616C75652862297D7D2C5F736176654F7468657256616C75653A66756E6374696F6E2862297B76617220633D746869733B696628247628622E6174747228226964222929297B';
wwv_flow_api.g_varchar2_table(7) := '696628247828227064656275672229297B617065782E64656275672827536176696E6720226F74686572222076616C756520666F7220272B622E617474722822696422292B223A20222B247628622E6174747228226964222929297D622E646174612863';
wwv_flow_api.g_varchar2_table(8) := '2E6F7074696F6E732E736176655461672C247628622E6174747228226964222929297D7D2C5F7361766553687574746C6556616C75653A66756E6374696F6E2862297B76617220653D746869732C663D61282223222B622E617474722822696422292B22';
wwv_flow_api.g_varchar2_table(9) := '5F4C45465422292E6368696C6472656E28226F7074696F6E22292C633D61282223222B622E617474722822696422292B225F524947485422292E6368696C6472656E28226F7074696F6E22292C643D5B5D3B632E656163682866756E6374696F6E28297B';
wwv_flow_api.g_varchar2_table(10) := '642E7075736828612874686973292E61747472282276616C75652229297D293B69662828662E6C656E6774683E30297C7C2828662E6C656E6774683D3D3D3029262628632E6C656E6774683E302929297B696628247828227064656275672229297B6170';
wwv_flow_api.g_varchar2_table(11) := '65782E64656275672827536176696E67202273687574746C65222076616C756520666F7220272B622E617474722822696422292B223A20222B642E6A6F696E28223A2229297D622E6461746128652E6F7074696F6E732E736176655461672C642E6A6F69';
wwv_flow_api.g_varchar2_table(12) := '6E28223A2229297D7D2C5F726573746F726556616C75653A66756E6374696F6E2862297B76617220633D746869733B696628622E686173436C617373282273687574746C652229297B632E5F726573746F726553687574746C6556616C75652862297D65';
wwv_flow_api.g_varchar2_table(13) := '6C73657B632E5F726573746F72654F7468657256616C75652862297D7D2C5F726573746F72654F7468657256616C75653A66756E6374696F6E2862297B76617220633D746869733B696628247828227064656275672229297B617065782E646562756728';
wwv_flow_api.g_varchar2_table(14) := '27526573746F72696E6720226F74686572222076616C756520666F7220272B622E617474722822696422292B223A20222B622E6461746128632E6F7074696F6E732E7361766554616729297D247328622E617474722822696422292C622E646174612863';
wwv_flow_api.g_varchar2_table(15) := '2E6F7074696F6E732E7361766554616729297D2C5F726573746F726553687574746C6556616C75653A66756E6374696F6E2862297B76617220663D746869732C673D66616C73652C643D61282223222B622E617474722822696422292B225F4C45465422';
wwv_flow_api.g_varchar2_table(16) := '292C653D622E6461746128662E6F7074696F6E732E73617665546167292E73706C697428223A22292C633D642E6368696C6472656E28226F7074696F6E22293B696628247828227064656275672229297B617065782E64656275672827526573746F7269';
wwv_flow_api.g_varchar2_table(17) := '6E67202273687574746C65222076616C756520666F7220272B622E617474722822696422292B223A20222B65297D632E656163682866756E6374696F6E28297B76617220683D612874686973293B666F7228766172206A3D303B6A3C652E6C656E677468';
wwv_flow_api.g_varchar2_table(18) := '3B6A2B2B297B696628682E61747472282276616C756522293D3D3D655B6A5D297B682E61747472282273656C6563746564222C2273656C656374656422293B673D747275657D7D7D293B69662867297B642E74726967676572282264626C636C69636B22';
wwv_flow_api.g_varchar2_table(19) := '297D7D7D297D2928617065782E6A5175657279293B';
null;
 
end;
/

 
begin
 
wwv_flow_api.create_plugin_file (
  p_id => 13205342412380769326 + wwv_flow_api.g_id_offset
 ,p_flow_id => wwv_flow.g_flow_id
 ,p_plugin_id => 28053058825171692526 + wwv_flow_api.g_id_offset
 ,p_file_name => 'com_skillbuilders_sbdp_save_value_on_cascade.min.js'
 ,p_mime_type => 'application/x-javascript'
 ,p_file_content => wwv_flow_api.g_varchar2_table
  );
null;
 
end;
/

commit;
begin 
execute immediate 'begin dbms_session.set_nls( param => ''NLS_NUMERIC_CHARACTERS'', value => '''''''' || replace(wwv_flow_api.g_nls_numeric_chars,'''''''','''''''''''') || ''''''''); end;';
end;
/
set verify on
set feedback on
prompt  ...done
