(function($){
$.widget('ui.apex_save_value_on_casdade', {
   options: {
      apexThis: {},
      saveTag: 'apex-value-saved'
   },
   _create: function () {
      var uiw = this;
      
      uiw.options.apexThis.affectedElements.each(function () {
         var $this = $(this);
         
         if ($x('pdebug')){
            apex.debug('Initializing Save Value on Cascade for ' + $this.attr('id'));
         }

         $this
            .data(uiw.options.saveTag, $v($this.attr('id')))
            .bind('change', function () {
               uiw._saveValue($this);
            })
            .bind('apexafterrefresh', function () {
               uiw._restoreValue($this);
            });
      });
   },
   _saveValue: function ($affectedElement) {
      var uiw = this;
      
      if ($affectedElement.hasClass('shuttle')) {
         uiw._saveShuttleValue($affectedElement);
      } else {
         uiw._saveOtherValue($affectedElement);
      }
   },
   _saveOtherValue: function ($affectedElement) {
      var uiw = this;
      
      if ($v($affectedElement.attr('id'))) {
         if ($x('pdebug')){
            apex.debug('Saving "other" value for ' + $affectedElement.attr('id') + ': ' + $v($affectedElement.attr('id')));
         }
         
         $affectedElement.data(uiw.options.saveTag, $v($affectedElement.attr('id')));
      }
   },
   _saveShuttleValue: function ($affectedElement) {
      var uiw = this,
         $shuttleLeftOpts = $('#' + $affectedElement.attr('id') + '_LEFT').children('option'),
         $shuttleRightOpts = $('#' + $affectedElement.attr('id') + '_RIGHT').children('option'),
         vals = [];
         
      $shuttleRightOpts.each(function () {
         vals.push($(this).attr('value'));
      });
      
      if (($shuttleLeftOpts.length > 0) || (($shuttleLeftOpts.length === 0) && ($shuttleRightOpts.length > 0))) {
         if ($x('pdebug')){
            apex.debug('Saving "shuttle" value for ' + $affectedElement.attr('id') + ': ' + vals.join(':'));
         }
         
         $affectedElement.data(uiw.options.saveTag, vals.join(':'));
      }
   },
   _restoreValue: function($affectedElement) {     
      var uiw = this;
      
      if ($affectedElement.hasClass('shuttle')) {
         uiw._restoreShuttleValue($affectedElement);
      } else {
         uiw._restoreOtherValue($affectedElement);
      }
   },
   _restoreOtherValue: function ($affectedElement) {
      var uiw = this;
      
      if ($x('pdebug')){
         apex.debug('Restoring "other" value for ' + $affectedElement.attr('id') + ': ' + $affectedElement.data(uiw.options.saveTag));
      }
      
      $s($affectedElement.attr('id'), $affectedElement.data(uiw.options.saveTag));
   },
   _restoreShuttleValue: function ($affectedElement) {
      var uiw = this,
         optsAdded = false,
         $shuttleLeft = $('#' + $affectedElement.attr('id') + '_LEFT'),
         $shuttleRightVals = $affectedElement.data(uiw.options.saveTag).split(':'),
         $leftOpts = $shuttleLeft.children('option');
      
      if ($x('pdebug')){
         apex.debug('Restoring "shuttle" value for ' + $affectedElement.attr('id') + ': ' + $shuttleRightVals);
      }
         
      $leftOpts.each(function () {
         var $leftOption = $(this);
         
         for (var i = 0; i < $shuttleRightVals.length; i++) {
            if ($leftOption.attr('value') === $shuttleRightVals[i]) {
               $leftOption.attr('selected', 'selected');
               optsAdded = true;
            }
         }
      });
      
      if (optsAdded) {
         $shuttleLeft.trigger('dblclick');
      }
   }
});
})(apex.jQuery);